
#include <sstream>

#include <boost/archive/polymorphic_xml_oarchive.hpp>
#include <boost/archive/polymorphic_xml_iarchive.hpp>
#include <boost/archive/xml_iarchive.hpp>
#include <boost/archive/xml_oarchive.hpp>

#include "cheind_a.hpp"
#include "cheind_b.hpp"

int main(int argc, char* argv[])
{
   A *a = new B();
   a->i = 3;

  std::stringstream ss;
 
  {
    boost::archive::polymorphic_xml_oarchive oa(ss);
    oa << BOOST_SERIALIZATION_NVP(a);
  }

  {
    A *loaded = 0;
    boost::archive::polymorphic_xml_iarchive ia(ss);
    ia >> BOOST_SERIALIZATION_NVP(loaded);
  }
  
  delete a;
  return 0;
}